// @author John Hawksley

// AJAX for the Archive Table

// LOADERS

function loadArchiveTable()
{
    var target = $("#dp-target").val() + "&date=" + $("#dp").val();

    $.ajax({
        url : target,
        cache : false,
        success : function(html)
        {
            $("#archiveStatusTable").html(html);
        }
    });
}

function loadConnectStatus()
{
    var target = $("#ajaxroot").val() + "?action=ajaxConnectStatus";

    $.ajax({
        url : target,
        cache : false,
        success : function(html)
        {
            $("#connectStatus").html(html);
        }
    });
}

function loadSizeDiv()
{  
    var target = $("#ajaxroot").val() + "?action=ajaxArchiveSizes";
    
    $.ajax({
        url : target,
        cache : false,
        success : function(html)
        {
            $("#archiveStatusDiv").html(html);
        }
    });
}

function computeArchiveSizes(selector, message)
{
    var target = $("#ajaxroot").val() + "?action=ajaxUpdateArchiveSizes";

    $(selector).removeAttr('href');
    $(selector).text(message);
    
    $.ajax({
        url : target,
        cache : false,
        async : false
    });
    
    // Now the sizes have been computed on the server
    loadSizeDiv();
}

function failureMessage(message)
{
    $("#archiveStatusTable").html(message);
    $("#connectStatus").html("");
}

var down = false;

function reloader()
{
    var currentSerial = $("#ajaxSerial").text();
    var target = $("#ajaxroot").val() + "?action=ajaxSerial";

    $
            .ajax({
                url : target,
                cache : false,
                success : function(newSerial)
                {
					$('#rotateNow').attr('disabled',false);
					$('#purgeNow').attr('disabled',false);
					$('#clearAll').attr('disabled',false);
				
                    if (newSerial == "")
                    {
                        down = true;
                        failureMessage("<div align=center><br/><b><i>FusionReactor is currently unavailable.</i></b><br/>Please ensure the FusionReactor instance is running.</div>");
                    } else if (newSerial != currentSerial || down == true)
                    {
                        down = false;
                        loadArchiveTable();
                        loadConnectStatus();
                        $("#ajaxSerial").html(newSerial);
                    }
                }
            });
}

function replaceAndFire(node, message, target, imgSrc)
{
    $(node).text(message);
    fireWrapper(target, imgSrc);

    return false;
}

function fire(target)
{
    // Fire and forget something
    redir = target.replace("__date", $("#dp").val());

    $.ajax({
        url : redir,
        cache : false
    });	
	
    return false;
}


// IMMEDIATES

$(document).ready(function()
{
    // Load the status divs
    loadSizeDiv();
    loadConnectStatus();
    reloader();

    window.setInterval('reloader()', 5000);
});

// --------------------------------------------------------------------------------------------------------------
// CALENDAR PICKER
// --------------------------------------------------------------------------------------------------------------

// Attaches the JQ cal picker to the node.
function attachCalendar(node)
{
    node.datepicker({
        dateFormat : 'yy-mm-dd',
        showButtonPanel : true,
        changeMonth : true,
        changeYear : true
    });

    node.change(function()
    {
        loadArchiveTable();
    });
}

// Advance the day

function advanceOrRetardDay(direction)
{
    var dp = $("#dp");
    var current = dp.val();
    var splits = current.split("-");

    var y = splits[0];
    var m = splits[1] - 1; // zero-based in JS
    var d = splits[2];
    var currentDate = new Date(y, m, d);

    if (direction == "advance")
        currentDate.setDate(currentDate.getDate() + 1);
    else if (direction == "retard")
        currentDate.setDate(currentDate.getDate() - 1);

    var mm, dd;
    var numericMonth = currentDate.getMonth() + 1;

    mm = numericMonth < 10 ? "0" + numericMonth : numericMonth;
    dd = currentDate.getDate() < 10 ? "0" + currentDate.getDate() : currentDate.getDate();

    var newDate = currentDate.getFullYear() + "-" + mm + "-" + dd;
    dp.val(newDate);
    dp.change();
}

// Causes a 'document.location' to the given location, replacing __date with the
// current calendar date.
function locate(target)
{
    redir = target.replace("__date", $("#dp").val());
    document.location = redir;
}

// Pops up a dialogue with the given message, then calls "location" with the
// target.
function confirmAndLocate(message, target)
{
    c = confirm(message);

    if (c)
    {
        locate(target);
    }
}

function confirmAndFire(message, target, imgSrc)
{
    c = confirm(message);

    if (c)
    {
        fireWrapper(target, imgSrc);
    }
}

function fireWrapper(location, imgSrc)
{
		$('#rotateNow').attr('disabled',true);
		$('#purgeNow').attr('disabled',true);
		$('#clearAll').attr('disabled',true);
        $("#archiveStatusTable").html('<br/><div align="center"><img src="' + imgSrc + '"/></div><br/>');
        $('#connectStatus').html('<br/><div align="center"><img src="' + imgSrc + '"/></div><br/>');
        fire(location);		
}

// Pops up a new window.
function pop(url)
{
    var newwindow = window.open(url, 'name', 'height=400,width=1000,scrollbars=1');

    if (window.focus)
    {
        newwindow.focus();
    }
}

function reloadCustom()
{
    var loc = $("#stem").val() + "&date=__date";
    locate(loc);
}
