/**
 * @author John Hawksley
 * 
 * AJAX/JS for the FPluginStatus / Notifications page
 */

/*
 * Load the plugin notification text.
 */

function update()
{
    var target = $("#ajaxroot").val() + "?fn=fPluginStatus_Notifications";

    $.ajax({
        url : target,
        cache : false,
        success : function(text)
        {
            if (text != "")
            {
                $("#ajaxPluginNotifications").html(text);
            }
            if (text == "No Messages")
            {
                $("#ajaxPluginNotifications").html(" ");
            }
        }
    });
}

$(document).ready(function()
{
    update();
    window.setInterval('update()', 5000);
});

// Take a URL, call it in the background, and change the link to "wait..."
function doLink(target, id)
{
    $(id).html("Wait...");

    $(id).attr('disabled', true);

    $.ajax({
        url : target,
        cache : false
    });
}

function dismissAll()
{
    var idlist = "";
    var target = $("#ajaxroot").val() + "?fn=fPluginStatus_Edits&cmd=dismissall";

    $(".notificationId").each(function(i)
    {
        idlist = idlist + $(this).text() + ",";
    });

    if (idlist != "")
    {
        idlist = idlist.substring( 0, idlist.length - 1);
    }
    
    idlist = "idlist=" + idlist;

    $("#dismissAllButton").html("Wait...");
    $("#dismissAllButton").attr("disabled", true);

    $.ajax({
        url : target,
        type : "POST",
        data : idlist,
        processData : false,
        cache : false
    });
}

function markAllRead()
{
    var idlist = "";
    var target = $("#ajaxroot").val() + "?fn=fPluginStatus_Edits&cmd=markallread";

    $(".notificationId").each(function(i)
    {
        idlist = idlist + $(this).text() + ",";
    });

    if (idlist != "")
    {
        idlist = idlist.substring( 0, idlist.length - 1);
    }
    
    idlist = "idlist=" + idlist;

    $("#markAllReadButton").html("Wait...");
    $("#markAllReadButton").attr("disabled", true);

    $.ajax({
        url : target,
        type : "POST",
        data : idlist,
        processData : false,
        cache : false
    });
}

function markAllUnread()
{
    var idlist = "";
    var target = $("#ajaxroot").val() + "?fn=fPluginStatus_Edits&cmd=markallunread";

    $(".notificationId").each(function(i)
    {
        idlist = idlist + $(this).text() + ",";
    });

    if (idlist != "")
    {
        idlist = idlist.substring( 0, idlist.length - 1);
    }

    idlist = "idlist=" + idlist;
    
    $("#markAllUnreadButton").html("Wait...");
    $("#markAllUnreadButton").attr("disabled", true);


    $.ajax({
        url : target,
        type : "POST",
        data : idlist,
        processData : false,
        cache : false
    });
}