<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xalan="http://xml.apache.org/xalan" xmlns:j2ee="http://java.sun.com/xml/ns/j2ee"
  xmlns:javaee="http://java.sun.com/xml/ns/javaee" xmlns:resin="http://caucho.com/ns/resin/core"
  xmlns:r="http://caucho.com/ns/resin" exclude-result-prefixes="j2ee javaee xalan resin r">

  <xsl:strip-space elements="*"/>
  <xsl:output method="xml" indent="yes" xalan:indent-amount="4"/>

  <xsl:variable name="FusionReactorFilter">
    <xsl:comment>FusionReactor filter - created ${date_time}</xsl:comment>
    <xsl:text>
    </xsl:text>
    <filter>
      <filter-name>FusionReactor</filter-name>
      <filter-class>com.intergral.fusionreactor.filter.FusionReactorFilter</filter-class>
      <init-param>
        <param-name>config</param-name>
        <param-value>${install_home}/instance/${instance_name}/conf/reactor.conf</param-value>
      </init-param>
    </filter>
    <filter-mapping>
      <filter-name>FusionReactor</filter-name>
      <url-pattern>/*</url-pattern>
    </filter-mapping>
    <xsl:text>
    </xsl:text>
  </xsl:variable>

  <!-- default identiy template -->
  <xsl:template match="*|@*|comment()|processing-instruction()|text()">
    <xsl:copy>
      <xsl:apply-templates select="*|@*|comment()|processing-instruction()|text()"/>
    </xsl:copy>
  </xsl:template>

  <!--  template for J2EE 2.5 spec -->
  <xsl:template match="/javaee:web-app/*[position()='1']">
    <xsl:copy-of select="$FusionReactorFilter"/>
    <xsl:copy-of select="."/>
  </xsl:template>

  <!--  template for J2EE 2.4 spec -->
  <xsl:template match="/j2ee:web-app/*[position()='1']">
    <xsl:copy-of select="$FusionReactorFilter"/>
    <xsl:copy-of select="."/>
  </xsl:template>

  <!-- template for default descriptors -->
  <xsl:template match="/web-app/*[position()='1']">
    <xsl:copy-of select="$FusionReactorFilter"/>
    <xsl:copy-of select="."/>
  </xsl:template>

  <!-- template matching Railo Resin -->
  <xsl:template match="//r:class-loader">
    <xsl:copy-of select="."/>
    <xsl:copy-of select="$FusionReactorFilter"/>
  </xsl:template>

</xsl:stylesheet>
