<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xalan="http://xml.apache.org/xalan" xmlns:j2ee="http://java.sun.com/xml/ns/j2ee"
    xmlns:javaee="http://java.sun.com/xml/ns/javaee" xmlns:resin="http://caucho.com/ns/resin/core"
    xmlns:r="http://caucho.com/ns/resin" exclude-result-prefixes="j2ee xalan resin r">

    <xsl:strip-space elements="*"/>

    <xsl:output method="xml" indent="yes" xalan:indent-amount="4"/>

    <!-- default identiy template -->
    <xsl:template match="*|@*|comment()|processing-instruction()|text()">
        <xsl:copy>
            <xsl:apply-templates select="*|@*|comment()|processing-instruction()|text()"/>
        </xsl:copy>
    </xsl:template>

    <!-- removes the comment before the the FusionReactor filter definition -->
    <xsl:template match="comment()">
        <xsl:if test="contains(current(), 'FusionReactor')=false">
            <xsl:copy/>
        </xsl:if>
    </xsl:template>

    <!-- Removes the FusionReactor filter definition -->
    <xsl:template match="/web-app/filter[filter-name[text()='FusionReactor']]"/>

    <!-- Removes the FusionReactor filter-mapping definition -->
    <xsl:template match="/web-app/filter-mapping[filter-name[text()='FusionReactor']]"/>


    <!-- Removes the FusionReactor filter definition -->
    <xsl:template match="//j2ee:filter[j2ee:filter-name[text()='FusionReactor']]"/>

    <!-- Removes the FusionReactor filter-mapping definition -->
    <xsl:template match="//j2ee:filter-mapping[j2ee:filter-name[text()='FusionReactor']]"/>


    <!-- Removes the FusionReactor filter definition -->
    <xsl:template match="//javaee:filter[javaee:filter-name[text()='FusionReactor']]"/>

    <!-- Removes the FusionReactor filter-mapping definition -->
    <xsl:template match="//javaee:filter-mapping[javaee:filter-name[text()='FusionReactor']]"/>


    <!-- Removes the FusionReactor filter definition -->
    <xsl:template match="//r:filter[r:filter-name[text()='FusionReactor']]"/>

    <!-- Removes the FusionReactor filter-mapping definition -->
    <xsl:template match="//r:filter-mapping[r:filter-name[text()='FusionReactor']]"/>

</xsl:stylesheet>
